#ifndef MAINWINDOW_H
#define MAINWINDOW_H
/*
 *
 * qmplayer - A Qt class for embedding MPlayer
 * Copyright (C) 2011 by Israel Lins Albuquerque
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
#include <QMainWindow>
#include "qmplayer.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
private:
    void addToTbMediaInfo(QString a_propertie, QString a_value);

private slots:
    void mplayerError(QMPlayer::ErrType, QString);
    void mplayerMediaInfoChanged();
    void mplayerStateChanged(QMPlayer::State a_new, QMPlayer::State a_old);
    void mplayerTick(qint64 a_tick);
    void mplayerParameterChanged(QMPlayer::Parameter a_p, qint32 a_newValue);

    void on_actionOpen_triggered();

    void on_actionQuit_triggered();

    void on_btnPlay_clicked();

    void on_btnStop_clicked();

    void on_btnBack_clicked();

    void on_btnFoward_clicked();

    void on_sldProgress_valueChanged(int position);

    void on_sldVolume_valueChanged(int value);

private:
    Ui::MainWindow* m_ui;
    QMPlayer* m_mplayer;
};

#endif // MAINWINDOW_H
