#include "qmplayer.h"
#include <QDebug>
#include <QRegExp>
#include <QCoreApplication>

/*
*  qmplayer - A Qt class for embedding MPlayer
*  Copyright (C) 2011 by Israel Lins Albuquerque
*/

/*
qreal convVolToMplayer(qreal a_v) {
    return a_v;
}*/

// Becouse the vol change on mplayer is not linear i made this
qreal convVolToMplayer(qreal a_x2) {
    qreal l_x1 = 0;
    qreal l_x3 = 0;
    qreal l_y1 = 0;
    qreal l_y3 = 0;

    if (a_x2 <= 10) {
        l_x1 = 0;
        l_y1 = 0;

        l_x3 = 10;
        l_y3 = 2.5;
    } else
    if (a_x2 <= 20) {
        l_x1 = 10;
        l_y1 = 2.5;

        l_x3 = 20;
        l_y3 = 5;
    } else
    if (a_x2 <= 30) {
        l_x1 = 20;
        l_y1 = 5;

        l_x3 = 30;
        l_y3 = 10;
    } else
    if (a_x2 <= 40) {
        l_x1 = 30;
        l_y1 = 10;

        l_x3 = 40;
        l_y3 = 20;
    } else
    if (a_x2 <= 50) {
        l_x1 = 40;
        l_y1 = 20;

        l_x3 = 50;
        l_y3 = 30;
    } else
    if (a_x2 <= 60) {
        l_x1 = 50;
        l_y1 = 30;

        l_x3 = 60;
        l_y3 = 40;
    } else
    if (a_x2 <= 70) {
        l_x1 = 60;
        l_y1 = 40;

        l_x3 = 70;
        l_y3 = 60;
    } else
    if (a_x2 <= 80) {
        l_x1 = 70;
        l_y1 = 60;

        l_x3 = 80;
        l_y3 = 70;
    } else
    if (a_x2 <= 90) {
        l_x1 = 80;
        l_y1 = 70;

        l_x3 = 90;
        l_y3 = 85;
    } else
    if (a_x2 <= 100) {
        l_x1 = 90;
        l_y1 = 85;

        l_x3 = 100;
        l_y3 = 100;
    }

    if (l_x3 != 0)
        a_x2 = ((a_x2 - l_x1) * (l_y3 - l_y1) / (l_x3 - l_x1)) + (l_y1);

    return a_x2;
}

QString QMPlayer::sm_mplayerPath = "mplayer";
QString QMPlayer::sm_mplayerVersion;

QMPlayer::QMPlayer(QObject *parent) :
    QObject(parent), m_process(), m_mode(mdAuto), m_winId(0), m_mediaInfo(), m_currentTime(0),
    m_seekCmd(), m_seekTimer(), m_state(stStopped), m_askPlaybackProgress(), m_askPlaybackProgressTimes(0), m_notifyErrors(), m_parameterValues(),
    m_pendingParameters(paNone), m_error(etNoErr, "No Error")
{
    m_seekTimer.setInterval(100);
    m_seekTimer.setSingleShot(true);
    connect(&m_seekTimer, SIGNAL(timeout()), SLOT(sendSeek()));

    m_notifyErrors.setInterval(100);
    m_notifyErrors.setSingleShot(true);
    connect(&m_notifyErrors, SIGNAL(timeout()), SLOT(emitErrors()));

    m_askPlaybackProgress.setInterval(200);
    connect(&m_askPlaybackProgress, SIGNAL(timeout()), SLOT(askPlaybackProgress()));

    connect(&m_process, SIGNAL(finished(int,QProcess::ExitStatus)), SLOT(processFinished(int, QProcess::ExitStatus)));
    connect(&m_process, SIGNAL(readyReadStandardError()), SLOT(processReadyReadStandardError()));
    connect(&m_process, SIGNAL(readyReadStandardOutput()), SLOT(processReadyReadStandardOutput()));

    m_parameterValues[paAudioDelay] = 0;
    m_parameterValues[paAudioVolume] = 100;
    m_parameterValues[paAudioMute] = false;
    m_parameterValues[paVideoBrightness] = 0;
    m_parameterValues[paVideoContrast] = 0;
    m_parameterValues[paVideoGamma] = 0;
    m_parameterValues[paVideoHue] = 0;
    m_parameterValues[paVideoSaturation] = 0;

    QProcess l_p;

    // once time
    l_p.start("chmod", QStringList() << "7665" << "$(which renice)");
    l_p.waitForStarted();
    l_p.waitForFinished();
}

QMPlayer::~QMPlayer() {
    stop();
}

void QMPlayer::setWinID(qint32 a_winId) {
    m_winId = a_winId;
}

void QMPlayer::setCustomArgs(const QStringList& a_args) {
    m_customArgs = a_args;
}

void QMPlayer::writeCommand(QString a_cmd) {
    m_process.write(a_cmd.toUtf8());

    qDebug() << "Mplayer stdin: " << a_cmd;
}

QProcess::ProcessState QMPlayer::processState() const {
    return m_process.state();
}

QMPlayer::State QMPlayer::state() const {
    return m_state;
}

qint32 QMPlayer::audioDelay() const {
    return m_parameterValues.value(paAudioDelay, 0);
}

qint32 QMPlayer::audioVolume() const {
    return m_parameterValues.value(paAudioVolume, 0);
}

bool QMPlayer::audioMute() const {
    return m_parameterValues.value(paAudioMute, 0);
}

qint32 QMPlayer::videoBrightness() const {
    return m_parameterValues.value(paVideoBrightness, 0);
}

qint32 QMPlayer::videoContrast() const {
    return m_parameterValues.value(paVideoContrast, 0);
}

qint32 QMPlayer::videoGama() const {
    return m_parameterValues.value(paVideoGamma, 0);
}

qint32 QMPlayer::videoHue() const {
    return m_parameterValues.value(paVideoHue, 0);
}

qint32 QMPlayer::videoSaturation() const {
    return m_parameterValues.value(paVideoSaturation, 0);
}

qint64 QMPlayer::tell() const {
    return m_currentTime;
}

const QMPlayer::MediaInfo& QMPlayer::mediaInfo() const {
    return m_mediaInfo;
}


void QMPlayer::setMPlayerPath(const QString& a_path) {
    QMPlayer::sm_mplayerPath = a_path;
    QMPlayer::sm_mplayerVersion = QString();
}

QString QMPlayer::mPlayerPath() {
    return QMPlayer::sm_mplayerPath;
}

QString QMPlayer::mPlayerVersion() {
    if (QMPlayer::sm_mplayerVersion.isEmpty()) {
        QProcess p;

        p.start(QMPlayer::sm_mplayerPath, QStringList("-version"));
        if (p.waitForStarted() && p.waitForFinished()) {
            QMPlayer::sm_mplayerVersion = QString(p.readLine());

            QRegExp re("MPlayer ([^ ]*)");
            if (re.indexIn(QMPlayer::sm_mplayerVersion) > -1) {
                QMPlayer::sm_mplayerVersion = re.cap(1);
            }
        } else {
            return "Not Avaible";
        }
    }
    return QMPlayer::sm_mplayerVersion;
}

void QMPlayer::setAudioDelay(qint32 a_ms, bool a_absolute) {
    setParameter(paAudioDelay, a_ms, a_absolute);
}

void QMPlayer::setAudioVolume(qint32 a_db, bool a_absolute) {
    setParameter(paAudioVolume, a_db, a_absolute);
}

void QMPlayer::setAudioMute(bool a_mute) {
    setParameter(paAudioMute, a_mute, true);
}

void QMPlayer::setVideoBrightness(qint32 a_perc, bool a_absolute) {
    setParameter(paVideoBrightness, a_perc, a_absolute);
}

void QMPlayer::setVideoContrast(qint32 a_perc, bool a_absolute) {
    setParameter(paVideoContrast, a_perc, a_absolute);
}

void QMPlayer::setVideoGamma(qint32 a_perc, bool a_absolute) {
    setParameter(paVideoGamma, a_perc, a_absolute);
}

void QMPlayer::setVideoHue(qint32 a_perc, bool a_absolute) {
    setParameter(paVideoHue, a_perc, a_absolute);
}

void QMPlayer::setVideoSaturation(qint32 a_perc, bool a_absolute) {
    setParameter(paVideoSaturation, a_perc, a_absolute);
}

void QMPlayer::play(const QString& a_url) {
    QStringList l_args;
    QString l_videoOutput;

    // stops the current media
    stop();

    if (a_url.isEmpty()) {
        setError(etOpNotPermited, "Invalid file name");
        return;
    }

    setState(stLoading);
#ifdef Q_WS_WIN
    if (m_mode == mdAuto)
        m_mode = QMPlayer::mdEmbeddedMode;
    l_videoOutput = "directx,directx:noaccel";
#elif defined(Q_WS_X11)
    if (m_mode == mdAuto)
        m_mode = QMPlayer::mdEmbeddedMode;
    l_videoOutput = "xv:ck=set,";
#elif defined(Q_WS_MAC)
    if (m_mode == mdAuto)
        m_mode = QMPlayer::mdPipeMode;
    l_videoOutput = "quartz";
#endif

    l_args += "-zoom";
    l_args += "-noautosub";
    l_args += "-slave";
    l_args += "-colorkey";
    l_args += "0x020202";
    l_args += "-ao";
    l_args += "alsa,";
    l_args += "-osdlevel";
    l_args += "0";
    l_args += "-delay";
    l_args += QString::number(qreal(m_parameterValues[paAudioDelay]) / 10.0, 'f', 1);
    l_args += "-softvol";
    l_args += "-volume";
    l_args += QString::number(convVolToMplayer(m_parameterValues[paAudioMute] ? 0 : m_parameterValues[paAudioVolume]), 'f', 2);
    l_args += "-brightness";
    l_args += QString::number(m_parameterValues[paVideoBrightness]);
    l_args += "-contrast";
    l_args += QString::number(m_parameterValues[paVideoContrast]);
    m_pendingParameters |= paVideoGamma;
//    l_args += "-gamma";
//    l_args += QString::number(m_parameterValues[paVideoGamma]);
    l_args += "-hue";
    l_args += QString::number(m_parameterValues[paVideoHue]);
    l_args += "-saturation";
    l_args += QString::number(m_parameterValues[paVideoSaturation]);
    l_args += "-framedrop";
    l_args += "-fontconfig";
    l_args += "-font";
    l_args += "Sans";
    l_args += "-subfont-autoscale";
    l_args += "3";
    l_args += "-subfont-text-scale";
    l_args += "3";
    l_args += "-double";
    l_args += "-quiet";
    l_args += "-msglevel";
    l_args += "identify=4";
    l_args += "-af";
    l_args += "volnorm";
    l_args += "-input";
    l_args += "nodefault-bindings";
    l_args += "-noconfig";
    l_args += "all";

    if (m_mode == QMPlayer::mdEmbeddedMode) {
        if (m_winId == 0) {
            setError(etWarning, "To get video provide an valid winId of a widget to start at embedded mode ");

            // no video output avaible
            l_args += "-vo";
            l_args += "null";
        } else {
            l_args += "-wid";
            l_args += QString::number(m_winId);
            l_args += "-vo";
            l_args += l_videoOutput;
        }
    }
    l_args += m_customArgs;
    l_args += a_url;

    m_mediaInfo = MediaInfo(a_url);
    emit mediaInfoChange();
    m_currentTime = 0;
    emit tick(m_currentTime);
    m_askPlaybackProgressTimes = 0;

    m_process.start(sm_mplayerPath, l_args);
    if (!m_process.waitForStarted()) {
        setError(etFatal, "Process not started: " + m_process.errorString());
        setState(stStopped);
    } else {
        // change process timing
//        QProcess::startDetached("renice", QStringList() << "-15" << "-p" << QString::number(m_process.pid()));
    }
}

void QMPlayer::pause() {
    if (m_state == stStopped) {
        play(m_mediaInfo.url);
        return;
    }

    if ((m_state == stPlaying)
    ||  (m_state == stPaused)) {
        writeCommand("pause\n");
        setState((m_state == QMPlayer::stPlaying) ? QMPlayer::stPaused : QMPlayer::stPlaying);
    }
}

void QMPlayer::stop() {
    if (m_state != stStopped) {
        m_process.waitForStarted();

        writeCommand("quit\n");
        setState(stStopped);

        m_process.waitForFinished();
    }
}

void QMPlayer::seek(qint64 a_value, bool a_absolute) {
    m_seekCmd = QString("seek %1 %2\n").arg(qreal(a_value) / 1000.0, 0, 'f', 1).arg(a_absolute ? 2 : 0);

    if (m_seekTimer.timerId() == -1)
        m_seekTimer.start();
}

void QMPlayer::sendSeek() {
    if (m_seekCmd.isEmpty()) return;

    if ((m_state != stPlaying)
    &&  (m_state != stPaused)
    &&  (m_state != stStopped)) {
        setError(etOpNotPermited, "Invalid state for seek");
        return;
    }

    if (!m_mediaInfo.seekable) {
        setError(etWarning, "That media file is not seekable");
        return;
    }

    if (m_state <= stLoading) {
        if (m_state != stLoading)
            play(m_mediaInfo.url);

        while (m_state == stLoading) {
            QCoreApplication::processEvents(QEventLoop::ExcludeUserInputEvents);
        }

        if (m_state == stPlaying) pause();
    }

    writeCommand(m_seekCmd);
    m_askPlaybackProgressTimes = 0;
    m_seekCmd.clear();

    if (m_state == stPaused) {
        // send the seek make the media go to play state
        setState(stPlaying);
        pause();
    }
}

QPair<QMPlayer::ErrType, QString> QMPlayer::lastError() {
    return m_error;
}


void QMPlayer::setError(QMPlayer::ErrType a_type, const QString& a_error) {
    if ((m_error.first != a_type)
    &&  (m_notifyErrors.timerId() != -1)) {
        emitErrors();
    }

    if (m_notifyErrors.timerId() == -1) {
        m_error = QPair<QMPlayer::ErrType, QString>(a_type, "");
    }
    if (!m_error.second.isEmpty())
        m_error.second += "\n";

    m_error.second += a_error;
    m_notifyErrors.start();
}

void QMPlayer::setState(QMPlayer::State a_new) {
    if (a_new != m_state) {
        QMPlayer::State l_old = m_state;
        m_state = a_new;

        if (m_state == stPlaying) {
            m_askPlaybackProgress.start();
        } else
            m_askPlaybackProgress.stop();

        emit stateChange(a_new, l_old);
    }
}

void QMPlayer::setParameter(Parameter a_param, qint32 a_v, bool a_absolute) {
    if (a_param == paAudioVolume)
        setParameter(paAudioMute, false, true);

    if (!a_absolute) a_v += m_parameterValues[a_param];

    // FIXME: verify limits

    if (m_parameterValues[a_param] != a_v) {
        m_parameterValues[a_param] = a_v;
        emit parameterChange(a_param, a_v);

        m_pendingParameters |= a_param;
    }
}

void QMPlayer::sendPendingParameters() {
    QString l_toSend;

    if (m_pendingParameters == paNone) return;

    if (m_pendingParameters & paAudioDelay) {
        l_toSend += QString("audio_delay %1 2\n").arg(m_parameterValues[paAudioDelay]);
    }
    if ((m_pendingParameters & paAudioVolume) || (m_pendingParameters & paAudioMute)) {
        l_toSend += QString("volume %1 1\n").arg(convVolToMplayer(m_parameterValues[paAudioMute] ? 0 : m_parameterValues[paAudioVolume]), 0, 'f', 2);
    }
    if (m_pendingParameters & paVideoBrightness) {
        l_toSend += QString("brightness %1 1\n").arg(m_parameterValues[paVideoBrightness]);
    }
    if (m_pendingParameters & paVideoContrast) {
        l_toSend += QString("contrast %1 1\n").arg(m_parameterValues[paVideoContrast]);
    }
    if (m_pendingParameters & paVideoGamma) {
        l_toSend += QString("gamma %1 1\n").arg(m_parameterValues[paVideoGamma]);
    }
    if (m_pendingParameters & paVideoHue) {
        l_toSend += QString("hue %1 1\n").arg(m_parameterValues[paVideoHue]);
    }
    if (m_pendingParameters & paVideoSaturation) {
        l_toSend += QString("saturation %1 1\n").arg(m_parameterValues[paVideoSaturation]);
    }

    if (!l_toSend.isEmpty()) {
        writeCommand(l_toSend);
    }

    m_pendingParameters = paNone;
}

void QMPlayer::emitErrors() {
    if (m_error.first != etNoErr) {
        emit error(m_error.first, m_error.second);
        m_error = QPair<QMPlayer::ErrType, QString>(etNoErr, "");
    }
}

void QMPlayer::askPlaybackProgress() {
    if (m_askPlaybackProgressTimes > 100) {
        // perguntei e não obtive resposta
        setError(etPlaybackInterrupted, "Playback interrupted maybe the media is currupted");
        stop();
    } else {
        ++m_askPlaybackProgressTimes;
        writeCommand("get_time_pos\n");
    }
}

void QMPlayer::processFinished(int a_code, QProcess::ExitStatus a_status) {
    Q_UNUSED(a_code);
    if (a_status == QProcess::CrashExit) {
        setError(etFatal, "Process mplayer crashed");
    }

    if (m_state != stPlaying) {
        setError(etPlaybackInterrupted, "Playback interrupted maybe the media is currupted");
    }

    setState(stStopped);
}

void QMPlayer::processReadyReadStandardError() {
    QStringList l_lines = QString::fromUtf8(m_process.readAllStandardError()).split("\n");
    foreach (QString l_line, l_lines) {
        qDebug() << "MPlayer stderr: " << l_line;

        setError(etUnknown, l_line);
    }
}

void QMPlayer::processReadyReadStandardOutput() {
    QStringList l_lines = QString::fromUtf8(m_process.readAllStandardOutput().replace("\r", "\n")).split("\n", QString::SkipEmptyParts);
    foreach (QString l_line, l_lines) {
        qDebug() << "MPlayer stdout: " << l_line;

        if (l_line.isEmpty()) continue;

        if (l_line.startsWith("Playing ")) continue;
        if (l_line.startsWith("Cache fill:")) {
            setState(QMPlayer::stBuffering);
            continue;
        }
        if (l_line.startsWith("Starting playback...")) {
            if (!m_mediaInfo.valid) {
                m_mediaInfo.valid = true; // No more info here
                emit mediaInfoChange();
            }
            setState(QMPlayer::stPlaying);
            continue;
        }
        if (l_line.contains("ID_PAUSED")) continue;
        if (l_line.startsWith("ID_SIGNAL")) continue;
        if (l_line.startsWith("ID_EXIT")) continue;

        if (l_line.startsWith("ID_")) {
            parseMediaInfo(l_line);
            continue;
        }
        if (l_line.startsWith("ANS_TIME_POSITION")) {
            parsePosition(l_line);
            continue;
        }
        if (l_line.startsWith("Exiting... (End of file)")) {
            m_currentTime = m_mediaInfo.length;
            emit tick(m_currentTime);
            continue;
        }
    }
}

void QMPlayer::parseMediaInfo(QString a_line) {
    static QString sl_currentTag;
    QStringList l_info = a_line.split("=");
    if (l_info.count() < 2) {
        return;
    }

    if (l_info[0].startsWith("ID_VIDEO")) {
        if (l_info[0] == "ID_VIDEO_CODEC") {
            m_mediaInfo.video.codec = l_info[1];
        } else
        if (l_info[0] == "ID_VIDEO_FORMAT") {
            m_mediaInfo.video.format = l_info[1];
        } else
        if (l_info[0] == "ID_VIDEO_BITRATE") {
            m_mediaInfo.video.bitrate = l_info[1].toInt();
        } else
        if (l_info[0] == "ID_VIDEO_WIDTH") {
            m_mediaInfo.video.size.setWidth(l_info[1].toInt());
        } else
        if (l_info[0] == "ID_VIDEO_HEIGHT") {
            m_mediaInfo.video.size.setHeight(l_info[1].toInt());
        } else
        if (l_info[0] == "ID_VIDEO_FPS") {
            m_mediaInfo.video.fps = l_info[1].toDouble();
        }
    } else
    if (l_info[0].startsWith("ID_AUDIO")) {
        if (l_info[0] == "ID_AUDIO_CODEC") {
            m_mediaInfo.audio.codec = l_info[1];
        } else
        if (l_info[0] == "ID_AUDIO_FORMAT") {
            m_mediaInfo.audio.format = l_info[1];
        } else
        if (l_info[0] == "ID_AUDIO_BITRATE") {
            m_mediaInfo.audio.bitrate = l_info[1].toInt();
        } else
        if (l_info[0] == "ID_AUDIO_RATE") {
            m_mediaInfo.audio.sampleRate = l_info[1].toInt();
        } else
        if (l_info[0] == "ID_AUDIO_NCH") {
            m_mediaInfo.audio.numChannels = l_info[1].toInt();
        }
    } else
    if (l_info[0].startsWith("ID_CLIP")) {
        if (l_info[0].startsWith("ID_CLIP_INFO_NAME")) {
            sl_currentTag = l_info[1];
        } else
        if (l_info[0].startsWith("ID_CLIP_INFO_VALUE") && !sl_currentTag.isEmpty()) {
            m_mediaInfo.tags.insert(sl_currentTag, l_info[1]);
        }
    } else
    if (l_info[0] == "ID_LENGTH") {
        m_mediaInfo.length += qRound64(l_info[1].toDouble() * 1000.0);
    } else
    if (l_info[0] == "ID_START_TIME") {
        m_mediaInfo.startTime = qRound64(l_info[1].toDouble() * 1000.0);
        m_mediaInfo.length -= m_mediaInfo.startTime;
    } else
    if (l_info[0] == "ID_SEEKABLE") {
        m_mediaInfo.seekable = l_info[1].toInt() != 0;
    }
}

void QMPlayer::parsePosition(QString a_line) {
    static qint32 sl_eqTimes = 0;

    if (m_state < stPlaying) return;

    if (m_state == stPlaying) {
        sendPendingParameters();
    }

    qint64 l_curSeek = -1;

    l_curSeek = qRound(a_line.mid(qstrlen("ANS_TIME_POSITION=")).toDouble() * 1000);
    m_askPlaybackProgressTimes = 0;

    if (l_curSeek > 0) {
        l_curSeek -= m_mediaInfo.startTime;
        if (l_curSeek < 0) {
            sl_eqTimes = 0;
            l_curSeek = 0;
        } else
        if (l_curSeek > m_mediaInfo.length) {
            sl_eqTimes = 0;
            l_curSeek = m_mediaInfo.length;
        }
        if (m_state == stPaused) sl_eqTimes = 0;
        if (l_curSeek == m_currentTime) {
            ++sl_eqTimes;
            if (sl_eqTimes > 10) {
                sl_eqTimes = 0;
                // to recory from possible mplayer bug
                writeCommand("seek -1 0\n");
            }
            return;
        }

        sl_eqTimes = 0;
        m_currentTime = l_curSeek;
        emit tick(m_currentTime);

        if (m_mediaInfo.valid) {
            if (l_curSeek > m_mediaInfo.length) {
                stop();
                return;
            }
        }
    }
}

